
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android数据库Realm实践 / iVAN</title>

    <meta name="description" content="Android数据库Realm实践 Android开发中常用的数据库有5个: 1. OrmLite OrmLite 不是 Android 平台专用的ORM框架,它是Java ORM.支持JDBC连接,Spring以及Android平台.语法中广泛使用了注解(Annotation). 2. SugarORM SugarORM 是 Android 平台专用ORM.提供简单易学的APIs.可以很容易的处理1对1和1对多的关系型数据,并通过3个函数save(), delete() 和 find() (或者 findById()) 来简化C">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android数据库Realm实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Android开发中常用的数据库有5个：</p>
<h5>1. <a href="http://ormlite.com/sqlite_java_android_orm.shtml" rel="external nofollow noreferrer">OrmLite</a></h5>
<p>OrmLite 不是 Android 平台专用的ORM框架，它是Java ORM。支持JDBC连接，Spring以及Android平台。语法中广泛使用了注解（Annotation）。</p>
<h5>2. <a href="http://satyan.github.io/sugar/getting-started.html" rel="external nofollow noreferrer">SugarORM</a></h5>
<p>SugarORM 是 Android 平台专用ORM。提供简单易学的APIs。可以很容易的处理1对1和1对多的关系型数据，并通过3个函数save(), delete() 和 find() (或者 findById()) 来简化CRUD基本操作。</p>
<h5><a href="http://greendao-orm.com/" rel="external nofollow noreferrer">3. GreenDAO</a></h5>
<p>当性能很重要时（数据访问频繁），GreenDao是一个很快的解决方案，它能够支持数千条记录的CRUD每秒，和OrmLite相比，GreenDAO要快几乎4.5倍。（准确数据请自行benchmark）。</p>
<p>GreenDAO小于100KB，所以对于应用程序APK的大小影响很小。</p>
<h5>4. <a href="http://www.activeandroid.com/" rel="external nofollow noreferrer">Active Android</a></h5>
<p>Active Record（活动目录）是Yii、Rails等框架中对ORM实现的典型命名方式。Active Android 帮助你以面向对象的方式来操作SQLite。<br />在你的项目中包含Active Android，你需要在项目的 /libs 目录下添加一个jar文件。可以从Github中获取源代码并使用Maven进行编辑。</p>
<h5>5. <a href="http://realm.io/" rel="external nofollow noreferrer">Realm</a></h5>
<p>Realm 是一个将可以使用的Android ORM，基于C++编写，直接运行在你的设备硬件上（不需要被解释），因此运行很快。它同时是开源跨平台的，iOS的代码可以在GitHub找到，你还可以找到Objective C以及Swift编写的Realm使用实例。</p>
<p>相比SQLite，Realm更快并且具有很多现代数据库的特性，比如支持JSON，流式api，数据变更通知，以及加密支持，这些都为安卓开发者带来了方便。</p>
<p>Ream提供了五种编程方式的实现。分别是Java，Objective<br />
 C，Swift，React-Native，tamarin。在这里我着重介绍在Android中的使用。</p>
<p>大家可以直接看官方的文档，我也是在这基础的上讲解：<a href="https://realm.io/cn/docs/java/latest/" rel="external nofollow noreferrer">realm使用</a></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA4MDUxNjE4MjkyNjM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p><strong>快速入门</strong>：</p>
<h3>运行环境</h3>
<ul>
<li>目前我们还不支持 Android 以外的 Java 环境；</li>
<li>Android Studio &gt;= 1.5.1 ；</li>
<li>较新的 Android SDK 版本；</li>
<li>JDK 版本 &gt;=7；</li>
<li>我们支持 Android API 9 以上的所有版本（Android 2.3 Gingerbread 及以上）。</li>
</ul>
<p>构建依赖关系</p>
<p>第一步： 在项目的 build.gradle 文件中添加如下 class path 依赖。</p>
<pre><code>buildscript {
    repositories {
        jcenter()
    }
    dependencies {
        classpath "io.realm:realm-gradle-plugin:1.0.0"
    }
}</code></pre>
<p>项目的 <code>build.gradle</code> 文件在如下位置：<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3JlYWxtLmlvL2Fzc2V0cy9pbWcvZG9jcy9qYXZhL3Byb2plY3QtbGV2ZWwtYnVpbGQtZ3JhZGxlLnBuZw==.jpg"></p>
<p>第二步： 在 app 的 build.gradle 文件中应用 <code>realm-android</code> 插件。</p>
<pre><code>apply plugin: 'realm-android'</code></pre>
<p>app的 <code>build.gradle</code> 文件在如下位置：<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3JlYWxtLmlvL2Fzc2V0cy9pbWcvZG9jcy9qYXZhL2FwcGxpY2F0aW9uLWxldmVsLWJ1aWxkLWdyYWRsZS5wbmc=.jpg"></p>
<p>如果读者使用的是maven构建项目，官方也有说明，这里我就不列出来了。<br />
<br />说到这里，我们已经迫不及待的想尝试下了。</p>
<p>1，application里面初始化</p>
<pre>public class RealmApplication extends Application {
    @Override
    public void onCreate() {
        super.onCreate();
        init();
    }

    private void init() {
        RealmConfiguration realmConfiguration = new RealmConfiguration.Builder(this).build();
        Realm.setDefaultConfiguration(realmConfiguration);
    }
}</pre>
<p>2，创建工具管理类，获取Realm实例</p>
<pre>public class RealmUtils {
    private static  RealmUtils instance;
    public final Context mContext;
    private String realmName = "realm_demo.realm";

    public RealmUtils(Context mContext) {
        this.mContext = mContext;
    }

    public  static  RealmUtils getInstance(Context context){
        if (instance == null) {
            synchronized (RealmUtils.class) {
                if (instance == null) {
                    instance = new RealmUtils(context);
                }
            }
        }
        return  instance;
    }

    public  Realm getRealm(){
        Realm realm =Realm.getInstance(new RealmConfiguration.Builder(mContext).name(realmName).build());
        return  realm;
    }
}</pre>
<p>3，创建一个realmObject对象，存储object<br />
<br />例如，我们现在需要存储一个人（Person）对象，注意，这里的成员属性为了realm的序列化，都写成私有的</p>
<pre>public class Person extends RealmObject {

    @PrimaryKey
    private String code;//编号
    private String name;//姓名
    private int age;//年龄

    public Person() {
    }

    public Person(int age, String code, String name) {
        this.age = age;
        this.code = code;
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    @Override
    public String toString() {
        return "Person{" +
                "code='" + code + '\'' +
                ", name='" + name + '\'' +
                ", age=" + age +
                '}';
    }
}</pre>
<p>4，定义几个CRUD的方法，供其它类实现</p>
<pre>public interface PersonDao {

    //插入
    void insert(Person person) throws Exception;

    //查询
    List&lt;Person&gt; getAllPerson() throws Exception;

    //更新
    Person updatePerson(Person person) throws Exception;

    //删除
    void deletePerson(String code) throws Exception;

    //    异步插入
    void insertPersonAsync(Person person) throws Exception;
}</pre>
<p>5，对象的具体实现</p>
<pre>public class PersonDaoImpl implements PersonDao {

    private Context context;
    private Realm mRealm;

    public PersonDaoImpl(Context context){
        mRealm = RealmUtils.getInstance(context).getRealm();
    }

    @Override
    public void insert(Person person) throws Exception {
        mRealm.beginTransaction();
        Person person1 = mRealm.copyToRealm(person);
        mRealm.commitTransaction();
        mRealm.close();
    }

    @Override
    public List&lt;Person&gt; getAllPerson() throws Exception {
        List&lt;Person&gt; mlist = null;
        mlist =  mRealm.where(Person.class).findAll();
        mRealm.close();
        return mlist;
    }

    @Override
    public Person updatePerson(Person person) throws Exception {
        mRealm.beginTransaction();
        Person person1 = mRealm.copyToRealmOrUpdate(person);
        mRealm.commitTransaction();
        mRealm.close();
        return  person1;
    }

    @Override
    public void deletePerson(String code) throws Exception {
        Person person = mRealm.where(Person.class).equalTo("code",code).findFirst();
        mRealm.beginTransaction();
        person.deleteFromRealm();
        mRealm.commitTransaction();
    }

    @Override
    public void insertPersonAsync(final Person person) throws Exception {
        //一个Realm只能在同一个线程中访问，在子线程中进行数据库操作必须重新获取Realm对象：
        mRealm.executeTransaction(new Realm.Transaction() {
            @Override
            public void execute(Realm realm) {
                realm.beginTransaction();
                Person person1 = realm.copyToRealm(person);
                realm.commitTransaction();
                realm.close();//并且要记得在离开线程时要关闭 realm.close();
            }
        });
        //关闭Realm对象
        mRealm.close();
    }
}</pre>
<p>6，测试</p>
<pre>public class MainActivity extends AppCompatActivity {

    private Realm mRealm;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
    }

    private void init() {
        Person person = new Person();
        person.setName("测试");
        person.setAge(28);
        person.setCode("xxxx");
        PersonDao dao = new PersonDaoImpl(this);

        try {
            //增加
            dao.insert(person);
             //查询全部
            dao.getAllPerson();
            //指定code删除
            dao.deletePerson("xxxx");
            //更新
            dao.updatePerson(person);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}</pre>
<p>其实这和以前的用法差不多的，有点在于，realm去帮我们管理这个数据库，并且在安全上我这还没有讲到，这里只讲了基本用法，大家可以去看看官方的文档说明：<br />
<br /><a href="https://realm.io/cn/docs/java/latest/" rel="external nofollow noreferrer">官方文档</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-05 10:15:59</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/new/" title="new">new</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/exception/" title="exception">exception</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/code/" title="code">code</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/gradle/" title="gradle">gradle</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android数据库Realm实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ4KjYM.html" rel="bookmark">Android数据库框架&mdash;&mdash;ORMLite轻量级的对象关系映射&lpar;ORM&rpar;Java包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android数据库框架--ORMLite轻量级的对象关系映射(ORM)Java包 事实上,我想写数据库的念头已经很久了,在之前写了一个答题系统的小项目那只是初步的带了一下数据库,数据库是比较强大的,不是我们三言两语就能解决的,我一直想抽个时间自己再过一遍Sqlite和JDBC的,但是,大家也知道,琐事比较多,我们来说一下数据库的框架吧,事实上市面上,我觉得还可以的数据库框架有两个,ORMLite和GreenDao,我以前做的运动类的应用上,就需要存储大量的运动数据,我们最开始是在本地写数据库的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b2ak3z.html" rel="bookmark">数据库综合开发实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据|数据库 数据库综合开发实践马磊.张万里 一套原来在Access上开发的桌面系统,网页调阅使用ASP编程,数据维护系统使用C++Builder编程.由于Access是一个桌面的共享型数据库,所以在通用性和网络开发方面都存在一些问题.因此,需要将该系统移植到服务器型的数据库上.使系统既可以通过桌面软件维护数据,又可以有大量用户通过网页调看数据(结果).系统初始软件为:Windows98第二版.Access97.C++Builder4.0.C++Builder5.0.MDAC(Microsoft			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91084M.html" rel="bookmark">android数据库储方式&lpar;一&rpar; SQLite的基本操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近开始在某个项目中实习,充分认识到了自己的不足,包括能力和性格等各种方面的缺陷.如何快速掌 握开发环境,如何与其他程序员沟通交流,如何准确知道分配给自己的模块具体实现的功能等等,都是大问题 ,更重要的是,自己不能仅仅只是写代码而已,还要清楚自己的代码的应用环境,别人是怎样用的,自己应该 提供哪些接口.这就属于扩展性的问题,不是一个新手能够马上明白的,但却是我们是否能够&quot;脱农&quot;的关键 . 废话不多说,本文讲诉的是我在项目中使用到的新知识---android数据库的操作.以前并没有任何			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPNGLqb.html" rel="bookmark">SQLite数据库操作实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 SQLite数据库操作实践 SQLite存储类型 null - 空值  integer - 有符号整数,自增列定义 id integer primary key autoincrement real - 浮点数,存储为8-byte IEEE浮点数  text - 文本字符串 使用数据库编码(UTF-8, UTF-16BE 或 UTF-16LE)进行存储 blob - 二进制数据,如图片.声音等等  也可以接受其它数据类型例如datetime,varchar,nvarchar,decimal,f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRwQRBp.html" rel="bookmark">android 数据库崩溃问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android 数据库崩溃问题 E/AndroidRuntime( 3752): android.database.sqlite.SQLiteException: unable to open database file (code 14) E/AndroidRuntime( 3752): at android.database.DatabaseUtils.readExceptionFromParcel(DatabaseUtils.java:181) E/AndroidRuntime(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQN2q0M.html" rel="bookmark">android开发-android数据库插入问题老是出错。新手。很急，在线等。谢谢大神了</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android数据库插入问题老是出错.新手.很急,在线等.谢谢大神了 public class MyDatabaseHelper extends SQLiteOpenHelper { final String CREATE_TABLE_SQL = &quot;create table dict(_id integer primary &quot; + &quot;key autoincrement , word , detail)&quot;; public MyDatabaseHelper(C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN1Zqyb.html" rel="bookmark">基于Sql Server 2008的分布式数据库的实践（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文 基于Sql Server 2008的分布式数据库的实践(四) 数据库设计 1.E-R图 2.数据库创建 Win 7 1 create database V3 Win 2003 1 create database V3 3.数据表设计 Win7 创建数据表student_7 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 create table student_7 (     sid int not null,     sex nvarchar(1) not nul			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZdqGYM.html" rel="bookmark">基于Sql Server 2008的分布式数据库的实践（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文 基于Sql Server 2008的分布式数据库的实践(二) 从Win7连接Win2003的Sql Server 2008 1.新建链接服务器链接到Win2003的Sql Server 2008 2.查看Win2003上面的IP地址,配置&quot;新建链接服务器&quot;中的&quot;常项&quot;   3.配置&quot;新建链接服务器&quot;中的&quot;安全项&quot;,本地登录为&quot;sa&quot;,远程用户也为&quot;sa&quot; 4.链接成功 Win7启动			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPJeqp.html" rel="bookmark">Android 开发之旅：短信的收发及在android模拟器之间实践（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 前面我们介绍都只是如何发送SMS消息,接下来我们介绍如何接收SMS消息,及另一种发短信的方式并增强为可以发生图片等,最后介绍一下emulator工具.本文的主要内容如下: 1~5见Android 开发之旅:短信的收发及在android模拟器之间实践(一) 6.温故知新之Intent 7.准备工作:SmsMessage类 8.SMS接收程序 9.另一种发送短信的方式:使用Intent 10.增强SMS为MMS 6.温故知新之Intent 此系列前面简单地接受过意图(Intent),这里再次简			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ71ob.html" rel="bookmark" class="title">MYSQL教程&colon;explain使用介绍</a>
					<div>
						explain显示了mysql如何使用索引来处理select语句以及连接表.可以帮助选择更好的索引和写出更优化的查询语句.使用方法:在select语句前加上explain. 如 EXPLAIN SEL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQONZp.html" rel="bookmark" class="title">手上的技巧：鼠绘关芝琳</a>
					<div>
						技巧 最终效果图: 第一步,用钢笔工具勾出脸型轮廓,转换成选区,用画笔上色,表示出大概的明暗关系. 第二步,确定五官的位置,调整(最好分图层画). 第三步,深入,调整:确定头发的大概形状和明暗关系.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ5RZb.html" rel="bookmark" class="title">使用C&num;开发Socket通讯</a>
					<div>
						下面的示例显示如何使用 Socket 类向 HTTP 服务器发送数据和接收响应. [C#] public string DoSocketGet(string server) {//Sets up va ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3x57M.html" rel="bookmark" class="title">使用C&num;的WebService实现客户端软件的在线升级功能</a>
					<div>
						web|客户端|在线 前言:由于项目原因,要实施的客户离作者(itbaby)太远,考虑提供软件的在线升级功能.我们如何实现呢!先讲下思路. 思路:先实现WEB端的开发,主要考虑使用WEBService ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjEV3p.html" rel="bookmark" class="title">Windows server 2003负载均衡的实现</a>
					<div>
						一.网络负载平衡的优点 1.网络负载平衡允许你将传入的请求传播到最多达32台的服务器上,即可以使用最多32台服务器共同分担对外的网络请求服务.网络负载平衡技术保证即使是在负载很重的情况下它们也能作出快 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr2oEp.html" rel="bookmark" class="title">Windows 8 Store Apps学习&lpar;28&rpar; 选取器&colon; CachedFileUpdater</a>
					<div>
						选取器: CachedFileUpdater(缓存文件更新程序) 介绍 重新想象 Windows 8 Store Apps 之 选取器 CachedFileUpdater - 缓存文件更新程序 示例  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7GYJb.html" rel="bookmark" class="title">UVa 757 &sol; POJ 1042 Gone Fishing&colon; 枚举&amp;amp&semi;amp&semi;贪心&amp;amp&semi;amp&semi;想法题&amp;amp&semi;amp&semi;优先队列</a>
					<div>
						757 - Gone Fishing Time limit: 3.000 seconds http://uva.onlinejudge.org/index.php?option=com_onlinej ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2LVOb.html" rel="bookmark" class="title">tp-link150m迷你无线路由怎么设置</a>
					<div>
						  tp-link150m迷你无线路由设置方法 在&quot;无线路由模式(Router)&quot;下,迷你型3G路由器和普通的无线路由器的功能是一样的;一般是用户办理了宽带业务的时候,选择使用&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR3y8z.html" rel="bookmark" class="title">十个必不可少的网络安全测试工具</a>
					<div>
						  安全漏洞似乎是司空见惯的新闻了,如某个公司或政府部门的网络安全受到破坏或渗透.如果您是一位安全专业人员,那么现在是时候更主动地应对安全问题了.多年以来,有很多人列出了最佳渗透测试和网络安全评估工具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYo3KM.html" rel="bookmark" class="title">QQ拼音输入法怎么打出点？QQ输入法打出间隔号</a>
					<div>
						  很多网友不知道怎样用QQ拼音输入法打出建个号&quot;·&quot;,下面小编就来教大家如何打出这个点. QQ拼音输入法怎么打出间隔号/点? 1.在输入框内输入&quot;vzf&quot;,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmxY5z.html" rel="bookmark" class="title">WinXP系统中设置共享出现问题怎么办</a>
					<div>
						  应用了guest为什么仍然不能访问 1.默认情况下,xp 禁用guest帐户 2.默认情况下,xp的本地安全策略禁止guest用户从网络访问 3.默认情况下,xp的本地安全策略-用户权限指派里,& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg31jZM.html" rel="bookmark" class="title">Android 异步加载图片的实例代码&lowbar;Android</a>
					<div>
						异步加载图片的主要流程是进行判断缓存中是否存在图片,如果存在则直接返回,如果不存在则进行下载并进行缓存. 以下是建立一个异步下载类: 复制代码 代码如下: /** * User: Tom * Date ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QNXmp.html" rel="bookmark" class="title">数据结构    c语言-C语言数据结构课程设计实现一个集合数据结构</a>
					<div>
						问题描述 C语言数据结构课程设计实现一个集合数据结构 题目:设计并实现一个集合数据结构Set.一个集合中没有重复元素,支持下列运算: boolean add(E o) 如果 set 中尚未存在指定的元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwELyp.html" rel="bookmark" class="title">大学生QQ相约自杀腾讯承担10&percnt;责任</a>
					<div>
						浙江省丽水市莲都区人民法院3日对一起大学生利用腾讯QQ网络相约自杀的民事赔偿纠纷作出一审判决,腾讯被判承担10%的责任. 原告为自杀大学生范某的父母,他们起诉称,今年6月,被告张某利用腾讯QQ向不特定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32dNNz.html" rel="bookmark" class="title">mongodb移除分片</a>
					<div>
						MongoDB的Shard集群来说,添加一个分片很简单,AddShard就可以了. 但是缩减集群(删除分片)这种一般很少用到.由于曙光的某服务器又挂了,所以我们送修之前必须把它上面的数据自动迁移到其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVXL3b.html" rel="bookmark" class="title">小心，别被伪造的iOS系统弹窗骗走Apple ID</a>
					<div>
						iPhone 和iPad 用户应该对图上的对话框非常熟悉了,iOS 系统会在用户登陆App Store或iTunes Store时弹出相应的对话框,要求验证Apple ID,而有时候根据应用使用情况以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6kolz.html" rel="bookmark" class="title">品读《HTTP请求响应过程以及与HTTPS区别》</a>
					<div>
						看这个社区很长时间了,今天想正式的记录下自己的一些工作的DD. 某会移动中间层Server,Server是为Mobile Client提供服务的应用,那么工作中用的到的Server通常部署2套,唯一区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRqj1b.html" rel="bookmark" class="title">Tornado 源码分析（一）</a>
					<div>
						tornado.gen.engine 是 tornado v3.0.0之前用于异步方法的. 具体点说如果一个方法内部使用yield 方法返回一个异步调用的结果, 那么这个方法必须使用tornado.g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyd13z.html" rel="bookmark" class="title">mysql数据库，workbench&comma;报错，sql格式错误？</a>
					<div>
						问题描述 mysql数据库,workbench,报错,sql格式错误? 建立数据库是卡住了 代码如下,最后三行的前面出来红色的×. 请问,什么问题? begin if new.item_type_id ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0n71mz.html" rel="bookmark" class="title">java io修改本地文件 Line&period;txt</a>
					<div>
						问题描述 java io修改本地文件 Line.txt 有一个本地文件Line.txt 文件中有一堆数据逗号分隔tno为第一个 status为最后一个 输入一个字符串判断Line中tno是否等于输入的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myea9dM.html" rel="bookmark" class="title">PaaS正能量：6人团队，仅1人全职后端 支撑6000万用户</a>
					<div>
						相信有很多人对PaaS持谨慎态度,到底是用还是不用?而在前一阶段&quot; 用户指责Heroku私自修改路由机制造成高支出&quot;这场风暴过境后,PaaS似乎变的更加让人望而却步了.然则PaaS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj88DZp.html" rel="bookmark" class="title">浅谈javascript中的闭包&lowbar;javascript技巧</a>
					<div>
						很长一段时间不理解闭包,后来了解了作用域,以及this相关问题才理解了闭包相关知识. 闭包(closure),也是面试题常客.简单点来说就是函数嵌套函数. 函数作为返回值: function foo  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NNmlb.html" rel="bookmark" class="title">浅谈JavaScript的闭包函数&lowbar;javascript技巧</a>
					<div>
						在JavaScript中,闭包恐怕是很多人不能理解的一个概念了,甚至很多人也会把闭包和匿名函数混淆. 闭包是有权访问另一个函数作用域中的变量的函数.首先要明白的就是,闭包是函数.由于要求它可以访问另一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5Y1az.html" rel="bookmark" class="title">浅谈Java反射与代理&lowbar;java</a>
					<div>
						Java反射机制与动态代理,使得Java更加强大,Spring核心概念IoC.AOP就是通过反射机制与动态代理实现的. 1 Java反射 示例: User user = new User(); use ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrRdop.html" rel="bookmark" class="title">nginx中fastcgi-cache缓存使用方法介绍</a>
					<div>
						fastcgi-cache缓存配置 配置自动清空缓存的步骤很简单: 1.检查是否安装ngx_purge_cache模块 nginx -V 2&gt;&amp;1 | grep nginx-cache- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLy7VM.html" rel="bookmark" class="title">Google的搜索引擎排名&lpar;SEO&rpar;优化策略</a>
					<div>
						    本文是针对三大搜索引擎做优化系列第三部分,针对Google做优化.本系列第一部分&quot;针对MSN优化&quot;,教你如何在MSN上取得好的排名.第二部分,&quot;针对Yahoo做优 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0lyVp.html" rel="bookmark" class="title">【SSH系列】Hibernate映射 -- 多对多关联映射</a>
					<div>
						     映射原理         在数据库学习阶段,我们知道,如果实体和实体之间的关系是多对多,那么我们就抽出来第三张表,第一张表和第二张表的主键作为第三表的联合主键,结合我们的hibernate, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jrBVp.html" rel="bookmark" class="title">Flex打开新窗口将主窗口数据传给子窗口然后返回&lowbar;Flex</a>
					<div>
						先说下我的需求: 主窗口打开子窗口,主窗口有数据传给打开的子窗口, 子窗口关闭时直接返回主窗口. --------------------------------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWVovz.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;中字符串中交换字符的问题</a>
					<div>
						问题描述 C++中字符串中交换字符的问题 // char* s = &quot;12&quot;;//为什么使用这样的方式会报错? char s[] = &quot;12&quot;; char t; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXd9OLp.html" rel="bookmark" class="title">微软BizTalk Server 2009对MSDN及TechNet公布</a>
					<div>
						Biz 为business的简称,talk为对话之意,所以该产品功能为各企业级商务应用程序间的消息交流之用. 在当今的业务环境中,越发需要创建业务流程,将各种分散的应用程序融为一体.借助于 Micro ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
